﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.IO;
using System.Windows;

namespace XMLVerify
{
    class CModell : CController
    {
        private static CModell instance = new CModell();

        private String filenameXML = "";
        private String filenameXSD_DTD = "";
        private String actualDirectory = Environment.CurrentDirectory;

        private String editXMLText = "";
        private String editXSDText = "";
        private Boolean bXMLModified = false;
        private Boolean bXSDModified = false;

        public String FilenameXML
        {
            get { return filenameXML; }
            set {
                filenameXML = value;
                ActualDirectory = Basis.getPath(filenameXML);
                OldFiles oldfiles = OldFiles.getInstance();
                oldfiles.deleteFileFromOldFiles(filenameXML);
                String file2;
                file2 = Basis.changeFilenameExt(value, "xsd");
                if (File.Exists(file2))
                {
                    filenameXSD_DTD = file2;
                }
                else
                {
                    file2 = Basis.changeFilenameExt(value, "dtd");
                    if (File.Exists(file2))
                    {
                        filenameXSD_DTD = file2;
                    }
                    else
                    {
                        filenameXSD_DTD = "";
                    }
                }

            }
        }


        public String FilenameXSD
        {
            get { return filenameXSD_DTD; }
            set { filenameXSD_DTD = value; }
        }


        public String EditXMLText   {
            get { return editXMLText; }
            set
            {
                editXMLText = value;
                bXMLModified = true;
            }
        }
        public String EditXSDText
        {
            get
            {
                return editXSDText;
            }
            set
            {
                editXSDText = value;
                bXSDModified = true;
            }
        }

        public String ActualDirectory
        {
            get { return actualDirectory; }
            set { actualDirectory = value; }
        }

        public Boolean XMLModified
        {
            get { return bXMLModified; }
            set { bXMLModified=value; }
        }
        public Boolean XSDModified
        {
            get { return bXSDModified; }
            set { bXSDModified = value; }
        }

        public static CModell getInstance()
        {
            return instance;
        }

        private CModell()
        {
        }


        public void loadFileXML()
        {
            FileStream oFile;

            if (!filenameXML.Equals("") && File.Exists(filenameXML))
            {
                oFile = new FileStream(filenameXML, FileMode.Open);
                StreamReader inStream = new StreamReader(oFile);
                editXMLText = inStream.ReadToEnd();
                inStream.Close();
                oFile.Close();
            }
            else
            {
                editXMLText = "";
            }
            this.bXMLModified = false;
        }


        public void loadFileXSD()
        {
            FileStream oFile;

            if (!filenameXSD_DTD.Equals("") && File.Exists(filenameXSD_DTD))
            {
                oFile = new FileStream(filenameXSD_DTD, FileMode.Open);
                StreamReader inStream = new StreamReader(oFile);
                editXSDText = inStream.ReadToEnd();
                inStream.Close();
                oFile.Close();
            }
            else
            {
                editXSDText = "";
            }
            this.bXSDModified = false;
        }

        public void saveAllFile(Boolean withXML, Boolean withXSD)
        {
            FileStream oFile;
            StreamWriter oStream;
            if (!filenameXML.Equals("") && withXML)
            {
                oFile = new FileStream(filenameXML, FileMode.Create);
                oStream = new StreamWriter(oFile);
                oStream.WriteLine(editXMLText);
                oStream.Close();
                oFile.Close();
                bXMLModified = false;
            }

            if (!filenameXSD_DTD.Equals("") && withXSD)
            {
                oFile = new FileStream(filenameXSD_DTD, FileMode.Create);
                oStream = new StreamWriter(oFile);
                oStream.WriteLine(editXSDText);
                oStream.Close();
                oFile.Close();
                bXSDModified = false;
            }
        }  // saveAllFile

        public void checkFile1()
        {
            if (bXMLModified)
            {
                MessageBoxResult res = Basis.readYesNoCancel("Sollen die Änderungen im XML-Editor gespeichert werden?", "Neue Datei laden");
                switch (res)
                {
                    case MessageBoxResult.Yes: saveAllFile(true, false);
                        break;
                    case MessageBoxResult.No:
                        break;
                    case MessageBoxResult.Cancel:
                        break;
                }
            }
        }

        public void checkFile2()
        {
            if (bXSDModified)
            {
                MessageBoxResult res = Basis.readYesNoCancel("Sollen die Änderungen im XSD-EDitor gespeichert werden?", "Neue Datei laden");
                switch (res)
                {
                    case MessageBoxResult.Yes: saveAllFile(false, true);
                        break;
                    case MessageBoxResult.No:
                        break;
                    case MessageBoxResult.Cancel:
                        break;
                }
            }
        }


    }
}
