﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Input;

namespace XMLVerify
{
    class MyCommands
    {
        private static RoutedUICommand openfile;
        private static RoutedUICommand savefile;
        private static RoutedUICommand saveasfile;
        private static RoutedUICommand newfile;

        private static RoutedUICommand undo;
        private static RoutedUICommand redo;
        private static RoutedUICommand copy;
        private static RoutedUICommand paste;
        private static RoutedUICommand cut;
        private static RoutedUICommand selectall;
        
        private static RoutedUICommand search;
        private static RoutedUICommand searchAgain;

        private static RoutedUICommand editor2Notepad;


        private static RoutedUICommand validation;
        private static RoutedUICommand validationXML;
        private static RoutedUICommand validationXSD;

        private static RoutedUICommand newInstanz;
        private static RoutedUICommand close;
        private static RoutedUICommand formatXML;
        private static RoutedUICommand formatXSD;
        private static RoutedUICommand wordwrap;

        private static RoutedUICommand standardProfi;

        private static RoutedUICommand optionen;
        private static RoutedUICommand progInfo;


        static MyCommands()
        {
            newfile = new RoutedUICommand("Neue Datei", "NewFile", typeof(MyCommands));
            newfile.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));  // ModifierKeys.Alt |

            openfile = new RoutedUICommand("Datei öfnen", "OpenFile", typeof(MyCommands));
            openfile.InputGestures.Add(new KeyGesture(Key.O, ModifierKeys.Control));  // ModifierKeys.Alt |

            savefile = new RoutedUICommand("Datei speichern", "SaveFile", typeof(MyCommands));
            savefile.InputGestures.Add(new KeyGesture(Key.S, ModifierKeys.Control));

            saveasfile = new RoutedUICommand("Datei speichern unter", "SaveAsFile", typeof(MyCommands));
            saveasfile.InputGestures.Add(new KeyGesture(Key.F12, ModifierKeys.None));

            undo = new RoutedUICommand("Undo", "undo", typeof(MyCommands));
            undo.InputGestures.Add(new KeyGesture(Key.Z, ModifierKeys.Control));
            redo = new RoutedUICommand("Redo", "redo", typeof(MyCommands));
            redo.InputGestures.Add(new KeyGesture(Key.Y, ModifierKeys.Control));

            copy = new RoutedUICommand("Kopieren", "Copy", typeof(MyCommands));
            copy.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control));

            paste = new RoutedUICommand("Einfügen", "Paste", typeof(MyCommands));
            paste.InputGestures.Add(new KeyGesture(Key.V, ModifierKeys.Control));

            cut = new RoutedUICommand("Ausschneiden", "Cut", typeof(MyCommands));
            cut.InputGestures.Add(new KeyGesture(Key.X, ModifierKeys.Control));

            selectall = new RoutedUICommand("Alles markieren", "selectall", typeof(MyCommands));
            selectall.InputGestures.Add(new KeyGesture(Key.A, ModifierKeys.Control));

            search = new RoutedUICommand("Suchen", "search", typeof(MyCommands));
            search.InputGestures.Add(new KeyGesture(Key.F, ModifierKeys.Control));

            searchAgain = new RoutedUICommand("Suchen", "search", typeof(MyCommands));
            searchAgain.InputGestures.Add(new KeyGesture(Key.F3, ModifierKeys.None));

            editor2Notepad = new RoutedUICommand("Show HTML-File in Notepad ", "editor2Notepad", typeof(MyCommands));
            editor2Notepad.InputGestures.Add(new KeyGesture(Key.D2, ModifierKeys.Control));


            validation = new RoutedUICommand("Valiadation", "valiadation", typeof(MyCommands));
            validation.InputGestures.Add(new KeyGesture(Key.F5, ModifierKeys.None));

            validationXML = new RoutedUICommand("Valiadation XML", "valiadationXML", typeof(MyCommands));
            validationXML.InputGestures.Add(new KeyGesture(Key.F6, ModifierKeys.None));

            validationXSD = new RoutedUICommand("Valiadation XSD", "valiadationXSD", typeof(MyCommands));
            validationXSD.InputGestures.Add(new KeyGesture(Key.F7, ModifierKeys.None));

        
            newInstanz = new RoutedUICommand("Valiadation XSD", "valiadationXSD", typeof(MyCommands));

            newInstanz = new RoutedUICommand("Neue Instanz", "newInstanz", typeof(MyCommands));
            
            close = new RoutedUICommand("Schließen", "close", typeof(MyCommands));
                        
            formatXML = new RoutedUICommand("Formatierung XML", "formatXML", typeof(MyCommands));

            formatXSD = new RoutedUICommand("Formatierung XSD", "formatXSD", typeof(MyCommands));

            wordwrap = new RoutedUICommand("Zeilenumbruch (WordWrap)", "wordwrap", typeof(MyCommands));

            standardProfi = new RoutedUICommand("Standard / Profisicht", "standardprofi", typeof(MyCommands));

            optionen = new RoutedUICommand("Optionen", "options", typeof(MyCommands));

            progInfo = new RoutedUICommand("Programm-Info", "progInfo", typeof(MyCommands));
        }


        public static RoutedUICommand Copy
        {
            get { return copy; }
        }
        public static RoutedUICommand Paste
        {
            get { return paste; }
        }
        public static RoutedUICommand Cut
        {
            get { return cut; }
        }


        public static RoutedUICommand Newfile
        {
            get { return newfile; }
        }

        public static RoutedUICommand Openfile
        {
            get { return openfile; }
        }

        public static RoutedUICommand Savefile
        {
            get { return savefile; }
        }


        public static RoutedUICommand SaveAsfile
        {
            get { return saveasfile; }
        }


        public static RoutedUICommand Undo
        {
            get { return undo; }
        }
        public static RoutedUICommand Redo
        {
            get { return redo; }
        }


        public static RoutedUICommand Selectall
        {
            get { return selectall; }
        }


        public static RoutedUICommand Search
        {
            get { return search; }
        }


        public static RoutedUICommand SearchAgain
        {
            get { return searchAgain; }
        }

        public static RoutedUICommand Editor2Notepad {
            get { return editor2Notepad; }
        }


        public static RoutedUICommand Validation
        {
            get { return validation; }
        }
        public static RoutedUICommand ValidationXML
        {
            get { return validationXML; }
        }
        public static RoutedUICommand ValidationXSD
        {
            get { return validationXSD; }
        }



        public static RoutedUICommand NewInstanz
        {
            get { return newInstanz; }
        }
            
        public static RoutedUICommand Close
        {
            get { return close; }
        }

                        
            
        public static RoutedUICommand FormatXML
        {
            get { return formatXML; }
        }

             
        public static RoutedUICommand FormatXSD
        {
            get { return formatXSD; }
        }



        public static RoutedUICommand Wordwrap
        {
            get { return wordwrap; }
        }

        public static RoutedUICommand StandardProfi
        {
            get { return standardProfi; }
        }


        public static RoutedUICommand Optionen
        {
            get { return optionen; }
        }


        public static RoutedUICommand ProgInfo
        {
            get { return progInfo; }
        }

    }
}
