﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Neu
using System.IO;
using System.Windows.Controls;

// neu in WPF
using System.Windows;
using System.Windows.Input;

namespace XMLVerify
{
    public class MyFileList : DockPanel, IView {
        ListBox listbox;
        ComboBox comboBox1;
        String path;
        Label lPath;
        SingVar singvar;

        private FileSystemWatcher fsw;

        public void setFontsize(int size)  {
            listbox.FontSize = size;
            comboBox1.FontSize = size;
            lPath.FontSize = size;            
        }


        public MyFileList()    {
            singvar = SingVar.getInstance();
            //this.Background = System.Windows.Media.Brushes.LightSeaGreen;
            CModell instance = CModell.getInstance();
            this.path = instance.ActualDirectory;
            if (!path.EndsWith("\\")) path += "\\";
            instance.addObserver(this);

            this.LastChildFill = true;
            this.HorizontalAlignment = HorizontalAlignment.Stretch;
            this.VerticalAlignment = VerticalAlignment.Stretch;


            lPath = new Label();
            lPath.Content = "Path";

            WrapPanel wrapPanelTop = new WrapPanel();
            wrapPanelTop.HorizontalAlignment = HorizontalAlignment.Left;
            wrapPanelTop.Children.Add(lPath);
            DockPanel.SetDock(wrapPanelTop, Dock.Top);
            this.Children.Add(wrapPanelTop);


            // Bottom
            WrapPanel wrapPanelBottom = new WrapPanel();
            comboBox1 = new ComboBox();
            insertLogicalDrives();

            Label laufwerk = new Label();
            laufwerk.Content = "Laufwerke:";
            wrapPanelBottom.Children.Add(laufwerk);
            wrapPanelBottom.Children.Add(comboBox1);
            DockPanel.SetDock(wrapPanelBottom, Dock.Bottom);
            this.Children.Add(wrapPanelBottom);

            listbox = new ListBox();
            DockPanel.SetDock(listbox, Dock.Bottom);
            this.Children.Add(listbox);

            createFileList();

            listbox.MouseDoubleClick += new MouseButtonEventHandler(listbox_MouseDoubleClick);
            comboBox1.SelectionChanged += new SelectionChangedEventHandler(comboBox1_SelectionChanged);
        }


        delegate void showFilesInListViewCallback(string actualPath);

        void FSW_Changed(object sender, FileSystemEventArgs e) {
            Application.Current.Dispatcher.Invoke(new Action(() => { createFileList(); }));
        }

        private void setFileWatcher(String actualPath) {
            if (actualPath.Length > 0) {
                fsw.Path = actualPath;
                fsw.Filter = "*.*";
                fsw.EnableRaisingEvents = true;
            }
        }  // setFileWatcher



        // string[] dirs = Directory.GetFiles(@"c:\", "c*");
        private void createFileList()
        {
            listbox.Items.Clear();
            // nicht im root
            if (path.Length > 3)
            {
                listbox.Items.Add(new FileObject("..", false, true));
            }

            lPath.Content = "Akt. Dir: " + Basis.getLastPath(path);
            lPath.ToolTip = path;


            string[] subdirectoryEntries = Directory.GetDirectories(path);
            foreach (string fileName in subdirectoryEntries)
            {
                listbox.Items.Add(new FileObject(Basis.getFilename(fileName), true, false));
            }
            string[] fileEntries = Directory.GetFiles(path, "*.xml");
            foreach (string fileName in fileEntries)
            {
                listbox.Items.Add(new FileObject(Basis.getFilename(fileName), false, false));
            }

        }


        private void listbox_MouseDoubleClick(object sender, RoutedEventArgs e)
        {
            FileObject fobj = (FileObject)listbox.SelectedItem;
            if (fobj.isParent)
            {
                DirectoryInfo dir = Directory.GetParent(path);
                path = dir.Parent.FullName;
                if (!path.EndsWith("\\")) path += "\\";
                createFileList();
            }
            else if (fobj.isDir)
            {
                path += fobj.name + "\\";
                createFileList();
            }
            else
            {
                CModell modell = CModell.getInstance();
                modell.checkFile1();
                modell.checkFile2();
                modell.FilenameXML = path + fobj.name;
                modell.notifyObservers();
            }

        }


        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            String sLw = (String)comboBox1.SelectedItem;
            if (sLw.Equals("Desktop"))
            {
                path = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            }
            else if (sLw.Equals("Meine Dokumente"))
            {
                path = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            }
            else if (sLw.Equals("Downloads"))
            {
                path = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
                path.Replace("Desktop", "Downloads");
            }
            else
            {
                path = sLw;
            }
            if (!path.EndsWith("\\")) path += "\\";
            createFileList();
        }


        void insertLogicalDrives()
        {
            try
            {
                comboBox1.Items.Clear();
                string[] drives = System.IO.Directory.GetLogicalDrives();

                foreach (string str in drives)
                {
                    comboBox1.Items.Add(str);
                }
                comboBox1.Items.Add("Desktop");
                comboBox1.Items.Add("Meine Dokumente");
                comboBox1.Items.Add("Downloads");
            }
            catch (System.IO.IOException)
            {
                System.Console.WriteLine("An I/O error occurs.");
            }
            catch (System.Security.SecurityException)
            {
                System.Console.WriteLine("The caller does not have the required permission.");
            }
        }

        public void update()
        {
        }
    }
}
